import numpy as np
import sys
# Para obtener la matriz de rotación, tenemos:
# o, sobre el cuerpo
# c, la posición de la cámara
# va, un vector para indicar donde es arriba
#       c - o
# zc = -------
#      ||c-o||
# 
#       va x zc
# xc = ---------
#      ||va x zc||
# 
# 
# yc = xc x zc
# 
#     [ xc^T ]
# R = [ yc^T ]
#     [ zc^T ]
# 
def norma( v ) :
	return np.sqrt( v[0,0]*v[0,0] + v[1,0]*v[1,0] + v[2,0]*v[2,0] )
	# return np.sqrt( v.T @ v  ) # 1x3 * 3x1 = 1x1

n = len(sys.argv)
if n != 10 :
	print( "Args: ox oy oz cx cy cz ax ay az" )
	sys.exit(1)

vo = np.array( [ [float(sys.argv[1])], [float(sys.argv[3])], [float(sys.argv[3])]] ) 
vc = np.array( [ [float(sys.argv[4])], [float(sys.argv[5])], [float(sys.argv[6])]] ) 
va = np.array( [ [float(sys.argv[7])], [float(sys.argv[8])], [float(sys.argv[9])]] ) 
print( "vo", vo )
print( "vc", vc )
print( "va", va )


# Así generamos la matriz de rotación
#
#      c - o
# zc = -------
#      ||c-o||
# 
#       va x zc
# xc = ---------
#      ||va x zc||
# 
# 
# yc = zc x xc
# 
#     [ xc^T ]
# R = [ yc^T ]
#     [ zc^T ]
vz = vc - vo
n = norma( vz )
vz /= n

vx = np.cross( va, vz, axisa=0, axisb=0, axisc=0 )
n = norma( vx )
vx /= n

vy = np.cross( vz, vx, axisa=0, axisb=0, axisc=0 )

print( vx )
print( vy )
print( vz )

R = np.zeros( (3,3) )
R[0,:] = vx.T
R[1,:] = vy.T
R[2,:] = vz.T

print( "R:" )
print( R )

print("Matriz R salvada en el archivo R.bin")
R.tofile("R.bin")
